package com.qmth.cqb.paper.service;


import java.util.List;

import com.qmth.cqb.question.model.Question;
import com.qmth.cqb.question.service.QuesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import com.qmth.cqb.paper.dao.PaperDetailUnitRepo;
import com.qmth.cqb.paper.model.PaperDetail;
import com.qmth.cqb.paper.model.PaperDetailUnit;

@Service
public class PaperDetailUnitService {
	@Autowired
	PaperDetailUnitRepo paperDetailUnitRepo;

	@Autowired
	QuesService quesService;

	/**
	 * 根据Id获得对应的试题对象
	 * @param id
	 * @return
	 */
	public Question getQuestionByPaperDetailUnitId(String id){
		PaperDetailUnit pdu = paperDetailUnitRepo.findOne(id);
		Question ques = quesService.findById(pdu.getId());
		return ques;
	}

    /**
     * 按ID查询小题
     * @param id
     * @return
     */
    public PaperDetailUnit findById(String id){
        return paperDetailUnitRepo.findOne(id);
    }

    /**
     * 保存小题
     * @param pdu
     * @return
     */
    public PaperDetailUnit savePaperDetailUnit(PaperDetailUnit pdu){
        PaperDetailUnit tempPdu = paperDetailUnitRepo.save(pdu);
        return tempPdu;
    }

    /**
     * 删除小题
     * @param id
     * @return
     */
    public void deletePaperDetailUnit(String id){
        paperDetailUnitRepo.delete(id);
    }

    /**
     * 根据大题查小题
     * @param paperDetail
     * @return
     */
    public List<PaperDetailUnit> getUnitsByPaperDetail(PaperDetail paperDetail){
    	PaperDetailUnit pdu = new PaperDetailUnit();
    	pdu.setPaperDetail(paperDetail);
    	List<PaperDetailUnit> units = paperDetailUnitRepo.findAll(Example.of(pdu));
    	return units;
    }
}

